﻿/* $Id: I2L_problems.j,v 1.10 2003/10/08 09:05:53 richard Exp $ */

TACTIC TheoremForward (thm) IS CUTIN (ALT thm (RESOLVE thm))

TACTIC TheoremForwardOrBackward(thm) IS
    WHEN    
        (LETHYP _A 
            (ALT    (TheoremForward (WITHHYPSEL (WITHARGSEL thm)))))
        (LETHYPS _As
            (Fail ("At present I2L Jape can't deal with multiple antecedent selections when applying theorems. Sorry.\
                    \\nCancel one of them and try again.")))
        (LETGOAL _A
            (ALT (WITHARGSEL thm) 
                (RESOLVE (WITHARGSEL thm)) 
                (TheoremForward (WITHARGSEL thm))
                (Fail   "Theorem application failed -- tell Richard")))
        (LETOPENSUBGOAL G _A 
            (Fail ("Error in I2L Jape (open subgoal in TheoremForwardOrBackward). Tell Richard.")))
        (LETOPENSUBGOALS _As
            (ALERT  ("There is more than one unproved conclusion in the proof. Please select one – \
                        \or select an antecedent – to show \
                        \Jape where to apply the theorem.")
                    ("OK", STOP) 
                    ("Huh?", Explainantecedentandconclusionwords)))
        (ALERT  "The proof is finished -- there are no unproved conclusions left."
                ("OK", STOP) 
                ("Huh?", Explainunprovedconclusionwords))

/* These theorems are all stated without an explicit left context Γ. That is possible because, in I2L_rules.j,
 * we declared a WEAKEN structure rule: Jape will automatically discard any unmatched left-context
 * formulae.
 */
  
/* Panels are declared in reverse order because the GUIs,  quite reasonably, create panels in the order requested.
 * Thus the last you ask for is the last created, and appears at the front of the stack.
 */

CONJECTUREPANEL "Ejercicios LP"
    THEOREM IS  p, p→q ⊦ q
    THEOREM IS  p→q, q→r, p ⊦ r
    THEOREM IS  p→(q→r), p→q, p ⊦ r
    THEOREM IS  p→q, q→r ⊦ p→r
    THEOREM IS  p→(q→r) ⊦ q→(p→r)
    THEOREM IS  p→(q→r) ⊦ (p→q)→(p→r)
    THEOREM IS  p ⊦ q→p
    THEOREM IS  ⊦ p→(q→p)
    THEOREM IS  p→q ⊦ (q→r)→(p→r)
    THEOREM IS  p→(q→(r→s)) ⊦ r→(q→(p→s))
    THEOREM IS  ⊦ (p→(q→r))→((p→q)→(p→r))
    THEOREM IS  (p→q)→r ⊦ p→(q→r)

    THEOREM IS  p, q ⊦ p∧q
    THEOREM IS  p∧q ⊦ p
    THEOREM IS  p∧q ⊦ q
    THEOREM IS  p∧(q∧r) ⊦ (p∧q)∧r
    THEOREM IS  (p∧q)∧r ⊦ p∧(q∧r)

    THEOREM IS  p∧q ⊦ p→q
    THEOREM IS  (p→q)∧(p→r) ⊦ p→(q∧r)
    THEOREM IS  p→(q∧r) ⊦ (p→q)∧(p→r)
    THEOREM IS  p→(q→r) ⊦ (p∧q)→r
    THEOREM IS  (p∧q)→r ⊦ p→(q→r)
    THEOREM IS  (p→q)→r ⊦ (p∧q)→r
    THEOREM IS  p∧(q→r) ⊦ (p→q)→r

    THEOREM IS  p ⊦ p∨q
    THEOREM IS  q ⊦ p∨q
    THEOREM IS  p∨q ⊦ q∨p

    THEOREM IS  q→r ⊦ (p∨q)→(p∨r)
    THEOREM IS  p∨p ⊦ p
    THEOREM IS  p ⊦ p∨p
    THEOREM IS  p∨(q∨r) ⊦ (p∨q)∨r
    THEOREM IS  (p∨q)∨r ⊦ p∨(q∨r)

    THEOREM IS  p∧(q∨r) ⊦ (p∧q)∨(p∧r)
    THEOREM IS  (p∧q)∨(p∧r) ⊦ p∧(q∨r)
    THEOREM IS  p∨(q∧r) ⊦ (p∨q)∧(p∨r)
    THEOREM IS  (p∨q)∧(p∨r) ⊦ p∨(q∧r)

    THEOREM IS  (p→r)∧(q→r) ⊦ (p∨q)→r
    THEOREM IS  (p∨q)→r ⊦ (p→r)∧(q→r)

    THEOREM IS  p ⊦ ¬¬p
    THEOREM IS  ¬p ⊦ p→q
    THEOREM IS  p→q ⊦ ¬q→¬p

    THEOREM IS  p∨q, ¬q ⊦ p
    THEOREM IS  p∨q, ¬p ⊦ q

    THEOREM IS  p∨q ⊦ ¬(¬p∧¬q)
    THEOREM IS  p∧q ⊦ ¬(¬p∨¬q)
    THEOREM IS  ¬(p∨q) ⊦ ¬p∧¬q
    THEOREM IS  ¬p∧¬q ⊦ ¬(p∨q)
    THEOREM IS  ¬p∨¬q ⊦ ¬(p∧q)
    THEOREM IS   ⊦ ¬(p∧¬p)

    THEOREM IS  p∧¬p ⊦ q

    THEOREM IS  ¬¬p ⊦ p

    THEOREM IS  ⊦ p∨¬p
    THEOREM IS  ⊦ ((p→q)→p)→p

    THEOREM IS  ¬q→¬p ⊦ p→q
    THEOREM IS  ¬(¬p∧¬q) ⊦ p∨q
    THEOREM IS  ¬(¬p∨¬q) ⊦ p∧q
    THEOREM IS  ¬(p∧q) ⊦ ¬p∨¬q
    THEOREM IS  (p→q)∨(q→p)

    BUTTON Apply IS apply TheoremForwardOrBackward COMMAND
END
